<?php
/**
* Joomla Community Builder User Plugin: plug_cbiplog
* @author Thomas Kampp, www.toolmaster.dk
* @copyright (C) Thomas Kampp, www.toolmaster.com
* @license Limited  http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

# Joomla/Mambo Safety
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class getIpLogTab extends cbTabHandler {
/*
	# Constructor
	function getIplogTab() {
		$this->cbTabHandler();
	}
*/

	# Create ip('s) for frontend!
	function showIp($user, $iplogIpAmount, $iplogError) {
		global $database;

    	$query = "SELECT DISTINCT userip FROM #__comprofiler_plug_iplog WHERE userid='".$user."' ORDER BY logdate ASC LIMIT 0, ".$iplogIpAmount;
		$database->setQuery( $query );
		// print $database->getQuery(); // test
		$ipdata = $database->loadObjectList();
		// print_r($ipdata); // test

		$amount=count($ipdata);
		if ($amount>0) { // check if this user actually has a first ip field
			$i=0; // counter
			while ($i<=$amount) {
				$ip=$ipdata[$i]->userip;
				$content .= $ip; // add ip to frontend result
				$i++; // 1 up
				if ($i<$amount) $content .= "<br>"; // insert break
			}
		} else { $content .= $iplogError; } // If the users IP has not yet been detected yet.

		return $content;
	}

	# Create text and insert IP for frontend!
	function showText($ip, $iplogText, $_CB_OneTwoRowsStyleToggle) {

		# Start output-content
		$content = "<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"100%\" class=\"cbStatusList\"><tr><td class=\"sectiontableentry".$_CB_OneTwoRowsStyleToggle."\" width=\"35%\" style=\"font-weight:bold;\">";
		$content .= $iplogText;
		$content .= "</td><td class=\"sectiontableentry".$_CB_OneTwoRowsStyleToggle."\"><span title=\"Users last used IP(s)\">";
		$content .= $ip;
		$content .= "</span></td></tr></table>";

		return $content;
	}

	# Add users ip to database!
	function addUserIp() {
		global $database, $my;

		# Find variables for database entry
		$userid = $my->id; // Find user id
		$userip = getenv('REMOTE_ADDR'); // Find user IP. Also  $_SERVER['REMOTE_ADDR'];  can be used!
		$logdate = date("y/m/d g:i:s"); // Find current date and time acoording to the server

		# Inserting into database
		$query1="INSERT INTO #__comprofiler_plug_iplog SET userid='$userid',  userip='$userip', logdate='$logdate'";
		$database->setquery($query1);
		// print $database->getQuery();
		$database->query();
	}

	# Check if the IP should be logged
	function detectUserIp($user, $iplogDetect, $iplogLogIp) { // refers to addUserIp()
		global $database, $my;

		# Detecting a users IP
		if (($iplogDetect=="0") AND ($my->id==$user)) { // Visiting own profile only!
			if ($iplogLogIp=="0") { // Every time possible!
				$this->addUserIp();
			} else if ($iplogLogIp=="1") { // Only if IP not registred before!
				$userid = $my->id; // Find user id
				$userip = getenv('REMOTE_ADDR'); // Find user IP. Also  $_SERVER['REMOTE_ADDR'];  can be used!
				$query2="SELECT COUNT(id) AS amount FROM #__comprofiler_plug_iplog WHERE userid='".$userid."' AND userip='".$userip."'";
				$database->setQuery($query2);
				// print $database->getQuery(); // test
				$row = $database->loadObjectList();
				# Add IP if not logged before (0)
				//$count=$row[0]->amount;
				if ($row[0]->amount==0) $this->addUserIp();
			}
		} else if ($iplogDetect=="1") { // Visiting any profile!
			if ($iplogLogIp=="0") { // Every time possible!
				$this->addUserIp();
			} else if ($iplogLogIp=="1") { // Only if IP not registred before!
				$userid = $my->id; // Find user id
				$userip = getenv('REMOTE_ADDR'); // Find user IP. Also  $_SERVER['REMOTE_ADDR'];  can be used!
				$query2="SELECT COUNT(id) AS amount FROM #__comprofiler_plug_iplog WHERE userid='".$userid."' AND userip='".$userip."'";
				$database->setQuery($query2);
				// print $database->getQuery(); // test
				$row = $database->loadObjectList();
				# Add IP if not logged before (0)
				//$count=$row[0]->amount;
				if ($row[0]->amount==0) $this->addUserIp();
			}
		}
		return;	
	}

	# Main funtions!
	function getDisplayTab($tab,$user) {
		global $mosConfig_absolute_path, $mosConfig_live_site, $database, $my, $_CB_OneTwoRowsStyleToggle;

		# Load parameters
		$params=$this->params;
		$iplogText = $params->get('iplogText', "Last logged IP");
		$iplogError = $params->get('iplogError', "None detected yet!");
		$iplogNoAdminLog = $params->get('iplogNoAdminLog', "0");
		$iplogDetect = $params->get('iplogDetect', "0");
		$iplogLogIp = $params->get('iplogLogIp', "1");
		$iplogShowIpTo = $params->get('iplogShowIpTo', "3");
		$iplogIpAmount = $params->get('iplogIpAmount', "1");

		# Find userlevels
		$is_user  = (strtolower($my->usertype) <> '');
		$is_admin = (strtolower($my->usertype) == 'administrator') || (strtolower($my->usertype) == 'super administrator');
		
		# Detect users IP - unless is admin and no admin log settings enabled
		if (!$iplogNoAdminLog AND $is_admin) { } else { $this->detectUserIp($user, $iplogDetect, $iplogLogIp); }

		# Show content
		if ($iplogShowIpTo!="0") { // None - just log IP's!
			if ($iplogShowIpTo=="1" AND $is_user) { // All registred users!
				$ip = $this->showIp($user->id, $iplogIpAmount, $iplogError);
				$content = $this->showText($ip, $iplogText, $_CB_OneTwoRowsStyleToggle);
			} else if (($iplogShowIpTo=="2" AND $is_user AND $my->id==$user->id) OR $is_admin) { // Owner and admins!
				$ip = $this->showIp($user->id, $iplogIpAmount, $iplogError);
				$content = $this->showText($ip, $iplogText, $_CB_OneTwoRowsStyleToggle);
			} else if ($iplogShowIpTo=="3" AND $is_admin) { // Admins only!
				$ip = $this->showIp($user->id, $iplogIpAmount, $iplogError);
				$content = $this->showText($ip, $iplogText, $_CB_OneTwoRowsStyleToggle);
			}
		}

		return $content;

	} // end getDisplayTab
}	// end class getIpLogTab.
?>